
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 White
#property indicator_color2 Yellow
#property indicator_color3 Red
#property indicator_color4 Green
//---- indicator parameters
extern int FastEMA=5;
extern int SlowEMA=9;
extern int SignalEMA=4;
//---- indicator buffers


double ind_buffer1[]; //DIF-WHITE
double ind_buffer2[]; //DEA-YELLOW
double ind_buffer3[]; //MACD-RED
double ind_buffer4[]; //MACD-GREEN


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 2 additional buffers are used for counting.
   IndicatorBuffers(5);
//---- drawing settings
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,1);
   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID,1);
   IndicatorDigits(int(MarketInfo(Symbol(),MODE_DIGITS)+1));
   SetIndexDrawBegin(2,SignalEMA);
   SetIndexDrawBegin(3,SignalEMA);
//---- 4 indicator buffers mapping

   SetIndexBuffer(0,ind_buffer1); //DIF-WHITE
   SetIndexBuffer(1,ind_buffer2); //DEA-YELLOW
   SetIndexBuffer(2,ind_buffer3); //MACD-RED
   SetIndexBuffer(3,ind_buffer4); //MACD-GREEN
   
   SetIndexLabel(0,"DIF");    //DIF-WHITE
   SetIndexLabel(1,"DEA");    //DEA-YELLOW
   SetIndexLabel(2,"Red");    //MACD-RED
   SetIndexLabel(3,"Green");  //MACD-GREEN  
   
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("MACD-2 ("+string(FastEMA)+","+string(SlowEMA)+","+string(SignalEMA)+")");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Oscillator                                                       |
//+------------------------------------------------------------------+
int start()
  {
   double prev,current;

   int counted_bars = IndicatorCounted();
   if(counted_bars < 0)  return(-1);
   if(counted_bars > 0)   counted_bars--;
   int limit = Bars - counted_bars;
   if(counted_bars==0) limit-=1+1;
   
//---- macd counted in the 1-st additional buffer
   for(int i=0; i<limit; i++)
      ind_buffer1[i]=iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);
//---- signal line counted in the 2-nd additional buffer
   for(i=0; i<limit; i++)
      ind_buffer2[i]=iMAOnArray(ind_buffer1,Bars,SignalEMA,0,MODE_SMA, i);
//---- dispatch values between 2 buffers
   bool up=true;
   for(i=limit-1; i>=0; i--)
     {
      current=ind_buffer1[i]-ind_buffer2[i];
      prev=ind_buffer1[i+1]-ind_buffer2[i+1];
      if(current>prev) up=true;
      if(current<prev) up=false;
      if(!up)
        {
         ind_buffer4[i]=3*current;
         ind_buffer3[i]=0.0;
        }
      else
        {
         ind_buffer3[i]=3*current;
         ind_buffer4[i]=0.0;
       
       }
     }
   return(0);
  }
//+------------------------------------------------------------------+
